package wa2.entities;

import java.io.*;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

/**
 * Created by Martin on 18. 2. 2015.
 */
public class CarRepository{
    private String Location = "C:/CarRepository";

    public void Save(Car car) throws IOException {

        String id = UUID.randomUUID().toString();

        String path = Paths.get(Location, id).toString();
        car.setId(id);

        serialize(car, path);

    }

    private void serialize(Car car, String path) throws IOException {
        FileOutputStream fos = new FileOutputStream(path);
        ObjectOutputStream oos = new ObjectOutputStream(fos);

        oos.writeObject(car);

        oos.close();
        fos.close();
    }

    public List<Car> GetAll() throws IOException {
        final ArrayList<Car> result = new ArrayList<Car>();

        Files.walk(Paths.get(Location)).forEach(
                file -> {
                    if(Files.isRegularFile(file)){
                        Car car = null;
                        try {
                            car = (Car)deserialize(file);
                        } catch (IOException e) {
                            e.printStackTrace();
                        } catch (ClassNotFoundException e) {
                            e.printStackTrace();
                        }
                        result.add(car);
                    }
                }
        );

        return result;

    }

    private Object deserialize(Path file) throws IOException, ClassNotFoundException {
        FileInputStream fis = new FileInputStream(file.toString());
        ObjectInputStream ois = new ObjectInputStream(fis);
        Object result = ois.readObject();

        ois.close();
        fis.close();

        return result;

    }
}
